Subject: Re: Let's abolish scope

From: [email-masked]
Date: Thu, 7 Aug 2003 13:47:43 -0700 (PDT)

> Date: Thu, 07 Aug 2003 13:58:22 +0200
> From: Brian E Carpenter <[email-masked]>
> Organization: IBM
> X-Mailer: Mozilla 4.79 [en] (Windows NT 5.0; U)
> X-Accept-Language: en,fr,de
> MIME-Version: 1.0
> To: [email-masked]
> Subject: Let's abolish scope [Re: Unicast scope field (was: Moving forward on 
>  Site-Local and Local Addressing)]
> 
> Well, here's my attempt at becoming flame bait :-)

Actually, this is the clearest summry of the current situation I've
seen yet.  I agree with many or your premises, but I believe you've
reached an incorrect conclusion.

> I'm close to concluding that address scope is simply a bogus concept.
> 
> 1. We've been arguing about it for years and have reached no sort of
> consensus. That suggests to me that there is in fact no consensus to be
> reached.

Worse yet, we're even arguing about whether there is a consensus.

> 2. Apart from link-local, scope boundaries are ill-defined.
> (What's a site? Is the whole of a corporate network a site? Is the DMZ
> inside or outside the site? etc.)

This is a feature, not a bug.  At least it was agreed that site
boundaries run through nodes and that any given link is either
entirely inside or outside of any given site.

> 3. We aren't clear whether we want scope because it maps security boundaries,
> reachability boundaries, routing boundaries, QOS boundaries, administrative 
> boundaries, funding boundaries, some other kinds of boundaries, or a 
> combination.

Different people want scope for different reasons, and others are
asserting that those reasons are not valid.  I think we should all
just agree to disagree on one another's reasons, because this part
of the discussion has become so polarized.

> 4. There are some well known and important scope-breaking phenomena, such
> as intermittently connected networks, mobile nodes, mobile networks, 
> inter-domain VPNs, hosted networks, network merges and splits, etc.
> Specifically, this means that scope *cannot* be mapped into concentric
> circles such as a naive link/local/global model. Scopes overlap and
> extend into one another. The scope relationship between two hosts may
> even be different for different protocols.

I'll agree with you there up to the last sentence, but I also don't
believe this is a bug.

> 5. In practice, scope is not explicit; it's implicit in firewall rules,
> VPN setup, static routes, DNS entries, application level trickery, 
> configuration files, and brains.

Perhaps so, and perhaps it should be more explicit.

> 6. Middleware (a.k.a. Apps) has no idea how to handle scope anyway. 
> In fact, given the above, I don't see how a useful API to express scope 
> concepts could be defined. If we can't define such an API, we can forget
> about expecting middleware to do anything sensible about scope.
> 
> So I don't believe that a scope field as part of the address format
> is a meaningful idea, because I don't think scope is a single-
> valued function in the first place.

Aha!  This is, of course, the meat of the current controversy.
And I agree with everyone who says that we shouldn't be forcing
application writers to deal with the scope swamp.

However:

I do (naively, perhaps) believe that the problem could be pushed
off of the shoulders of the application writer onto the shoulders
of the library writer.  I think the most logical place is in
getaddrinfo, which should have a new hints flag to tell it to
explicitly consider scope in ordering the items returned, so that
the first addrinfo struct returned contains the address most
likely to succeed.

No, I don't have running code or an Internet Draft to prove
the feasibility of this suggestion.  Sorry.

> I think we'd be better off to simply forget about address scope.

Certainly the length and acrimoniousness of the discussion
has inclined me toward this view at times, but I don't think we
should give up on it completely yet.

But we should probably proceed expeditiously with the deprecation
of FEC0::/10 just so the mailing list can get back to real
business.  As long as the prefix remains reserved, we can come
back and revive scoped addressing when we understand it better.

As an interested amateur in this area, I thank you for your
attention and now return you to the qualified participants in
the discussion.                         -- George Mitchell

>    Brian
> 
> - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
> Brian E Carpenter 
> Distinguished Engineer, Internet Standards & Technology, IBM 
> 
> NEW ADDRESS <[email-masked]> PLEASE UPDATE ADDRESS BOOK

--------------------------------------------------------------------
IETF IPng Working Group Mailing List
IPng Home Page:                      http://playground.sun.com/ipng
FTP archive:                      ftp://playground.sun.com/pub/ipng
Direct all administrative requests to [email-masked]
--------------------------------------------------------------------